//=============================================================================
// File: OAuthTestClient.java
// Date        Author     Changes
// ----------------------------------------------------------------------------
// 03/31/2006  AuthName   Created
// 04/03/2006  SomeXX     Added new method foo()
//=============================================================================
package com.logistic.webservice;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

import java.net.HttpURLConnection;
import java.net.URL;
import java.security.GeneralSecurityException;

/**
 * Very basic sample code that demonstrates how to make an OAuth 1.0
 * System-to-System
 */
public class OAuthTestClient {

    String strurl = "http://logisticinfotech.com/";

    public static void main(final String[] args) throws Exception {
        OAuthTestClient client = new OAuthTestClient();
        client.doRegister();
    }

    public void doRegister() throws GeneralSecurityException, IOException {
		// Setup the variables necessary to create the OAuth 1.0 signature and
        // make the request
        HttpURLConnection request = null;
        BufferedReader in = null;

        String xauth = OAuthSignatureUtil.generateConsumerSignature();

        System.out.println(String.format("X-Authorization request header = %s",
                xauth));

        // Add the oauth_signature parameter to the set of OAuth Parameters
        try {
            URL url = null;
            String api = null;
            String passingParams = null;

            api = "rest/login/v1.0/checkUser";
            passingParams = "?" + xauth;
            //passingParams = "";
            String postBody = "{JSON DATA}";

            url = new URL(strurl + api + passingParams);
            System.out.println("url :" + url);
            request = (HttpURLConnection) url.openConnection();
            request.setDoOutput(true);
            request.setRequestMethod("POST");
            request.setRequestProperty("Content-Type", "application/json");
            request.setRequestProperty("charset", "utf-8");
            System.out.println("Content=Lenght: " + Integer.toString(postBody.getBytes().length));
            request.setRequestProperty("Content-Length",
                    "" + Integer.toString(postBody.getBytes().length));

            OutputStreamWriter wr = new OutputStreamWriter(
                    request.getOutputStream());
            wr.write(postBody);
            wr.flush();

            // Send Request & Get Response
            InputStreamReader reader = new InputStreamReader(
                    request.getInputStream());

            in = new BufferedReader(reader);

            // Get the response stream
            String response = in.readLine();

            System.out.println("response:" + response);

            System.out.println(String.format("Successful Response: \r\n%s",
                    response));
        } catch (IOException e) {
            // This exception will be raised if the serve didn't return 200 - OK
            e.printStackTrace();
            System.out.println("Exception: " + e.getMessage());
        } finally {
            if (in != null) {
                in.close();
            }

            if (request != null) {
                request.disconnect();
            }

            System.out.println("finally");
        }
    }

}
